////////////////////////////////////////////////////////////////////////////
//  1997 , Horst Klaes GmbH & Co KG, Hauptstrae 2, 53506 Ahrbrck 
////////////////////////////////////////////////////////////////////////////
// File			: error_pl.H
// Projekt		:
////////////////////////////////////////////////////////////////////////////
// Author		: Ralf Karle, 1997
////////////////////////////////////////////////////////////////////////////
// Letzte Bearbeitung:
// Inhalt:
// 
//
////////////////////////////////////////////////////////////////////////////
#ifndef INCLUDE_ERROR_PL_H
# define INCLUDE_ERROR_PL_H



#define ERROR_THALESBIBLIOTHEK_RTL    500
#define ERROR_THALESBIBLIOTHEK_INTERN 501 // > 600
#define ERROR_THALESBIBLIOTHEK_WIN32  600


//Prototypen 

DLL_DECL void B_on_error_goto( void );
DLL_DECL void B_on_local_error_goto( void );
DLL_DECL void B_on_error_pop( void );
DLL_DECL long B_err( void );
DLL_DECL long B_erl( void );
DLL_DECL void B_set_errorcode( long Fehlercode );
DLL_DECL void B_set_errorline( long FehlerZeile );
DLL_DECL void B_Error( long Fehlercode , const char* szFile, long CppLine);
DLL_DECL void B_throw( long Fehlercode , const char* szFileName, long CppLine);

void CheckForIOErrorAndThrowIt(void);
void CheckForLastErrorErrorAndThrowIt(void);
void SystemError(char* FileName, long FileLine);   // vom Compiler


#define B_THROW( Fehlercode ) B_throw( Fehlercode, __FILE__, __LINE__ )


#endif	//INCLUDE_ERROR_PL_H
/*EOF*/