////////////////////////////////////////////////////////////////////////////
//  1997 , Horst Klaes GmbH & Co KG, Hauptstrae 2, 53506 Ahrbrck 
////////////////////////////////////////////////////////////////////////////
// File			: THALES.H
// Projekt		:
////////////////////////////////////////////////////////////////////////////
// Author		: Ralf Karle, 1997
////////////////////////////////////////////////////////////////////////////
// Letzte Bearbeitung:
// Inhalt:
// 
//
////////////////////////////////////////////////////////////////////////////


#ifndef INCLUDE_ERROR_PL
# define INCLUDE_ERROR_PL


#pragma warning( disable : 4102 )	// Disable Warning unreferenced Label

// Warning level 3 mit 
#pragma warning( 3 : 4706 ) // assignment within conditional
#pragma warning( 3 : 4100 ) // unreferenced formal parameter 

#include <error_pl.h>	//Prototypen

class DLL_DECL KPopError
{
public:
	KPopError();	 
	~KPopError();
};

class DLL_DECL KImCatchBlock
{
public:
	KImCatchBlock();
	~KImCatchBlock();
};


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// STANDARD Fehler - Behandlung

////////////////////////////////////////////////////////////////////////
// Werfen einer Exception
//#define B_THROW( Fehlercode ) B_throw( Fehlercode, __FILE__, __LINE__ )
// verlegt nach error_pl.h
////////////////////////////////////////////////////////////////////////
// Werfen einer Exception
#define B_error( Fehlercode ) B_Error( Fehlercode, __FILE__, __LINE__ )

////////////////////////////////////////////////////////////////////////
// Setzen einer Errorline
#define B_EL( FehlerNummer )   M_##FehlerNummer:      
#if 0
                             {  M_##FehlerNummer:      } \
                                B_set_errorline( FehlerNummer);   \
                             }
#endif
///////////////////////////////////////////////////////////////////////
// ON (Local) ERROR GOTO + Start des Try Blockes + Deklaration des ResumeSteuerWertes
#define B_ON_ERROR_GOTO(Label)				int ResumeSteuerWert = 0;\
											KPopError lkPopError;	 \
											do { \
											B_on_error_goto(); \
											try {

#define B_ON_LOCAL_ERROR_GOTO(Label)		int ResumeSteuerWert = 0;\
											KPopError lkPopError;	 \
											B_on_local_error_goto();\
											do {\
											try {

///////////////////////////////////////////////////////////////////////
// CATCHBLOCK + POP des On ERROR - STACK
#define B_CATCH_GLOBAL_ERROR					 ResumeSteuerWert = 0; \
											 }\
											 catch (int)\
											 {

#define B_CATCH_LOCAL_ERROR					 ResumeSteuerWert = 0; \
											 }\
											 catch (long)\
											 {\
											 KImCatchBlock lkImCatchBlock;

///////////////////////////////////////////////////////////////////////
// Ende des CATCH BLOCKES
#define B_CATCH_END(FunktionsName)			 ResumeSteuerWert = 0;\
											 End_Catch_##FunktionsName:; \
											 } } while (ResumeSteuerWert);

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// RESUME Realisation

////////////////////////////////////////////////////////////////////////
// RESUME
//		Resumewert aus LABEL ermitteln und ans Ende des Catchblockes Springen
//		LABEL = END_CATCH_+>Funktionsname< 
//		z.B. P_TestOpen ( ) -> LABEL = End_Catch_P_TestOpen( )
#define B_RESUME(FunktionsName, LabelNr) 				ResumeSteuerWert = LabelNr;\
																	goto End_Catch_##FunktionsName;

////////////////////////////////////////////////////////////////////////
// RESUMESTEUERWERT
//		Zugriff auf den Steuerwert
#define B_RESUMESTEUERWERT											ResumeSteuerWert

////////////////////////////////////////////////////////////////////////
// RESUME durchfhren auf Label 
#define B_RESUME_AT_LABEL( LabelName )							goto LabelName;


#endif