/* BASIC -> C Uebersetzung vom Thu Aug 21 12:51:00 1997
 *
 * Modul: Z:\INSTALPK\ARAMIS\SAMPLES\CPP\DEMO.CPP
 *
 */

#include "DEMO.H"




void	main(void)
{
	B_ARRAY(B_Int) intarrayI_f(1,1L,(long)5);	
		/* Initialisierung */
	B_initstring(DSTR,MAXSTRING,M_AXSP);
	B_initfeld(21);
	B_init(2);
	
	/* Benutzerprogramm */
		//Im Kopf des Konvertats wird ein Headerfile 'demo.h'
		//mit folgendem Inhalt eingebunden :
		//- Definitionen (Windows,...)
		//- Einbindung der Headerdatei fuer die Library
		//- Auflistung aller Konstanten (Defines)
		//- Einbindung der Headerdatei 'demo.typ' (Konvertat)
		//- Einbindung der Headerdatei 'vcommon.h' (Konvertat)
		//- Einbindung der Headerdatei 'projekt.h' (User)
		//- Deklaration von Funktionen, Prozeduren und Variablen
		//ALLGEMEIN
		//Das Konvertat jeder Datei.BAS besteht aus folgenden Dateien:
		//- C/CPP-Files datei.c/cpp
		//- Headerfile datei.h (s.o.)
		//- TYP-File mit den Usertypes
		//- vcommon.c/cpp mit globalen Variablen (bei Einstellung)
		//- vcommon.h mit Deklaration der entsprechenden Variablen
#undef PI
#define PI	(3.141592)

	// COMMON  SHARED globalvar%;
	GVglobalvarI=0;
	P_demofile();
	P_demostring();
	GVglobalvarI=F_demoarray(REFHI(2));
	P_demovar(REFHI(1));
		// ****************** FILE I/O ************************
	B_exit(0);
}

void   P_demofile(void)
{
	typ	usertyp;	
	 
	usertyp.intvar=1;
	usertyp.stringvar=BS("USER1 ");
	B_open(BS("RANDOM"),1,BS("datei1.txt"),sizeof(usertyp));
	B_putk(1, 1,sizeof(usertyp),&(usertyp));
	B_close(1);
	B_open(BS("RANDOM"),1,BS("datei1.txt"),sizeof(usertyp));
	B_getk(1, 1,sizeof(usertyp),&(usertyp));
	B_open(BS("OUTPUT"),2,BS("datei2.txt"),-1);
	B_fprintf(2,"%d\t, \t%.*s\n",usertyp.intvar,B_strlen(usertyp.stringvar),B_strptr(usertyp.stringvar));
	B_closeall();
}
	// ****************** STRINGS ************************

void   P_demostring(void)
{
	typ	usertyp;	B_String FS(fixstringS,6);
	B_String quellstringS;
	B_String zielstringS;
	
	 
	 
	 
	 
	quellstringS=BS("links mitte rechts");
	fixstringS=quellstringS;
	usertyp.stringvar=B_right(quellstringS, 6);
	zielstringS=fixstringS+B_mid(quellstringS,7, 6)+usertyp.stringvar;
	if((long)(zielstringS != quellstringS))
	{
		B_printf(-1,-1,"Fehler bei String-Konkatenation\n");
	}
	else
	{
		B_printf(-1,-1,"QuellString = \t%s\n",B_strptr(quellstringS));
		B_printf(-1,-1,"ZielString = \t%s\n",B_strptr(zielstringS));
	}
}
	// ****************** FUNKTION, ARRAYS ,SCHLEIFE und SELECT CASE ***

B_Int  F_demoarray(B_Int  &intvarI)
{
	B_Int  demoarrayI = 0;
	typ	usertyp;
	B_ARRAY(B_Int) intarrayI_f(1,1L,(long)5);
	B_Int  iI = 0;
	
	 
	 
	for(iI=1;iI<=5;(iI)++)
	{
		intarrayI_f.gA(1,iI)=iI;
	}
	switch(intvarI)
	{
		case 1:
			B_printf(-1,-1,"%d\n",intarrayI_f.gA(1,1));
			break;
		default:
			if(((intvarI) >= 2  && (intvarI) <= 5))
			{
				B_printf(-1,-1,"%d\n",intarrayI_f.gA(1,intvarI));
			}
			else
			{
				B_printf(-1,-1,"Index out of Range\n");
			}
			break;
		}
	demoarrayI=intarrayI_f.gA(1,intvarI);
	return(demoarrayI);
}
	// ****************** LOKALE/GLOBALE VARIABLEN *****************

void   P_demovar(B_Int  &intvarI)
{
	B_Int  localvarI = 0;
	
	 
	localvarI=2*PI;
	GVglobalvarI=localvarI*intvarI;
}	
	