/*
 * Copyright (C) 1994-2000 Cicero ISS
 *
 * Releaseversion: 1.8 6.2.95 Stefan Brueck
 *
 * Versionsgeschichte:
 * 1.11.94 Ausgabe der Releaseversion 1.0, lokale Aenderungen gegen die zentral
 *         gepflegte Release sind jeweils im Abschnitt 'Aenderungen gegen... '
 *         einzutragen und werden spaeter fuer alle in die Releaseversion ueber-
 *         nommen
 *
 * Aenderungen gegen Releaseversion:
 * 1) CT300196	Verhindern von mehrfach-Include
 * 2) CT150296	Deaktivieren des fehlplazierten Schalters WINDOWS_umdefinieren_fuer_OS2
 *				fuer WINDOWS
 *
 */
/* 1) CT300196	Verhindern von mehrfach-Include */
#ifndef __B_NACH_C_H__
#define __B_NACH_C_H__

/* * 2) CT150296	Deaktivieren des fehlplazierten Schalters WINDOWS_umdefinieren_fuer_OS2 */
#if 0

#define WINDOWS_umdefinieren_fuer_OS2 1

#else   /* * 2) CT150296 */

#ifdef OS2	/* Aktiv nur fuer OS2-LIB/DLL */
#define WINDOWS_umdefinieren_fuer_OS2 1
#endif

#endif	/* * 2) CT150296 */

#include <bnc_ver.h>	/* Versionsnummern und Flags */
#include <bnc_def.h>	/* Definitionen */
#include <bnc_pro.h>	/* BASIC-Prototypen */
#include <bnc_rsc.h>	/* Resourcedefinitionen */
#ifdef THALESPLUS	//ab.. 28.2.97
# include <error_pl.h>	/* Prototypen vom Exceptionhandling */
#endif

#endif /* __B_NACH_C_H__ */

