/*************************************************************
* Projekt:	VBNC				
* Modul:	BC_REFH.HPP	Klasse REFHx() Ersatz C++
* Autor:	Claus Tucher		CiceroSoft GmbH
* Datum:	26.11.1996
**/

#ifndef	B_REFH_HPP
# define B_REFH_HPP

/*************************************************************
* I N C L U D E
*/

/*************************************************************
* D E F I N E
*/

// Ref-Strings werden einfach ueber das Makro das ehedem schon 
// fuer das Anlegen temp. Klassen notwendig ist verwirklicht.
#define DS(x)	B_String(x, B_explicit)


/*************************************************************
* F U N K T I O N E N
* M O D U L S C H N I T T S T E L L E
*/



/*************************************************************
* F U N K T I O N E N
* M O D U L S C H N I T T S T E L L E
* C O D E
*/


/*************************************************************
* C L A S S E S
*/

template <class T>
class B_Ref
{
public:
	T		value;						// temp. Puffervariable zur Uebernahme des Wertes

	B_Ref(void)			{};				// default Konstruktor
	B_Ref(T initValue);					// Konstruktor

	T&	gR(void);						// Zugriffsfunktion: getReferenz
};


// Strings einfach ueber Makro da ehedem schon Klassen
//#define DS(x)	B_String(x, B_explicit)
//ab.. 22.1.97 verlegt nach thalespl.h

#undef B_NOINLINE   // Weil Templates zur Instanzierung immer eingebunden werden muessen, auch wenn nicht inline

#ifndef B_NOINLINE   // festlegen wenn Debuger keine Inlines debuggen kann
  #define B_INLINE inline
  #ifndef  BI_REFH_HPP
    #include "bi_refh.hpp"
  #endif
#endif


#endif	// B_REFH_HPP
/* E O F */