#ifndef BSTR_TP_HPP
# define BSTR_TP_HPP


/* ab.. 29.1.97 Prototypen fuer ueberladene Funktionen, die Thalesfunktionen aufrufen */

/*********** Gruppe 1 : Parameter mit B_Strings **************************************/
DLL_DECL B_Int B_getk(B_Int nr, B_Lng satz,const B_String& string);
DLL_DECL B_Int B_getk(B_Int nr, B_Lng satz, const B_TStringStruct string);
DLL_DECL B_Int B_putk(B_Int nr, B_Lng satz,const B_String& string);
DLL_DECL B_Int B_putk(B_Int nr, B_Lng satz, const B_TStringStruct string);
DLL_DECL void  B_chdir(const B_String& szDirName);
DLL_DECL void  B_chdir(const B_TStringStruct szDirName);
DLL_DECL B_Int B_exist(const B_String& pfad);
DLL_DECL B_Int B_exist(const B_TStringStruct pfad);
DLL_DECL void  B_kill(const B_String& szFileName);
DLL_DECL void  B_kill(const B_TStringStruct szFileName);
DLL_DECL void  B_name(const B_String& szOldName, const B_String& szNewName);
DLL_DECL void  B_name(const B_TStringStruct szOldName, const B_TStringStruct szNewName);
DLL_DECL B_Int B_open(const B_String& mode, B_Int nr, const B_String& pfad, B_Int anz);
DLL_DECL B_Int B_open(const B_String& mode, B_Int nr, const B_TStringStruct pfad, B_Int anz);
DLL_DECL B_Int B_valint(const B_String& str_wert);
DLL_DECL B_Int B_valint(const B_TStringStruct str_wert);
DLL_DECL B_Int B_cvi(const B_String& str_wert);
DLL_DECL B_Int B_cvi(const B_TStringStruct str_wert);
DLL_DECL B_Lng B_cvl(const B_String& str_wert);
DLL_DECL B_Lng B_cvl(const B_TStringStruct str_wert);
DLL_DECL B_Flt B_cvs(const B_String& str_wert);
DLL_DECL B_Flt B_cvs(const B_TStringStruct str_wert);
DLL_DECL B_Dbl B_cvd(const B_String& str_wert);
DLL_DECL B_Dbl B_cvd(const B_TStringStruct str_wert);

//DLL_DECL int B_shell(const B_String& command);
//DLL_DECL int B_shell(const B_TStringStruct command);

/*********** Gruppe 1 - Ende *********************************************************/


/*********** Gruppe 2 : Rueckgabe von B_String ***************************************/
DLL_DECL B_String B_mkiS(short a);
DLL_DECL B_String B_mklS(long a);
DLL_DECL B_String B_mksS(float a);
DLL_DECL B_String B_mkdS(double a);
DLL_DECL B_String B_itoabS(int n,int stellen,int rst);
DLL_DECL B_String B_utoabS(unsigned int n,int stellen,int rst);
DLL_DECL B_String B_ltoabS(long n,int stellen,int rst);
DLL_DECL B_String B_lutoabS(unsigned long n,int stellen,int rst);
DLL_DECL B_String B_ftoabS(double x, int gesamtlaenge, int nachkommastellen);
DLL_DECL B_String B_hexS(long nbr,int n);
DLL_DECL B_String B_octS(long nbr,int n);
DLL_DECL B_String B_binS(long a, int l);
//DLL_DECL B_String B_chrS(unsigned char a);	//ab.. 5.2.97 von Homer
DLL_DECL B_String B_timeS(void);
DLL_DECL B_String B_dateS(void);
/*********** Gruppe 2 - Ende *********************************************************/

/*********** Gruppe 3 : B_String in Parameterliste und Rueckgabe ********************/
DLL_DECL B_String B_dpath(void);
DLL_DECL B_String B_dpath(const B_cCStr& pfad);
DLL_DECL B_String B_dpath(const B_String& pfad);
DLL_DECL B_String B_dpath(const B_TStringStruct pfad);
DLL_DECL B_String B_curdir(const B_cCStr& lw, ...);
DLL_DECL B_String B_curdir(const B_String& lw, ...);
DLL_DECL B_String B_curdir(const B_TStringStruct lw, ...);

#endif	//BSTR_TP_HPP