'Im Kopf des Konvertats wird ein Headerfile 'demo.h' 
'mit folgendem Inhalt eingebunden :
'- Definitionen (Windows,...)
'- Einbindung der Headerdatei fuer die Library
'- Auflistung aller Konstanten (Defines)
'- Einbindung der Headerdatei 'demo.typ' (Konvertat)
'- Einbindung der Headerdatei 'vcommon.h' (Konvertat)
'- Einbindung der Headerdatei 'projekt.h' (User)
'- Deklaration von Funktionen, Prozeduren und Variablen


'ALLGEMEIN
'Das Konvertat jeder Datei.BAS besteht aus folgenden Dateien:
'- C/CPP-Files datei0 bis dateix 
'- Headerfile datei.h (s.o.)
'- TYP-File mit den Usertypes
'- vcommon.c/cpp mit globalen Variablen (bei Einstellung)
'- vcommon.h mit Deklaration der entsprechenden Variablen

DECLARE SUB demoFile
DECLARE SUB demoString
DECLARE FUNCTION demoArray% (BYVAL intVar%)
DECLARE SUB demoVar(intVar%)


TYPE typ
intVar		AS INTEGER
stringVar	AS STRING * 6
arrayVar(5) AS INTEGER
END TYPE

CONST PI = 3.141592
COMMON SHARED globalVar%


globalVar% = 0
demoFile
demoString
globalVar% = demoArray(2)
demoVar(1)



REM ****************** FILE I/O ************************
SUB demoFile
DIM userTyp AS typ

userTyp.intVar = 1
userTyp.stringVar = "USER1 "

OPEN "datei1.txt" FOR RANDOM AS #1 LEN = LEN(userTyp)
PUT #1, 1, userTyp
CLOSE #1
OPEN "datei1.txt" FOR RANDOM AS #1 LEN = LEN(userTyp)
GET #1, 1, userTyp
OPEN "datei2.txt" FOR OUTPUT AS #2
PRINT #2 userTyp.intVar, ", ",userTyp.stringVar
CLOSE
END SUB


REM ****************** STRINGS ************************
SUB demoString
DIM userTyp AS typ
DIM fixString AS STRING * 6
DIM quellString AS STRING, zielString AS STRING

quellString$		= "links mitte rechts"
fixString$			= quellString$
userTyp.stringVar	= RIGHT$(quellString$, 6)

zielString$ = fixString + MID$(quellString$, 7, 6) + userTyp.stringVar

IF (zielString$ <> quellString$) THEN
 PRINT "Fehler bei String-Konkatenation"
ELSE
 PRINT "QuellString = ", quellString$
 PRINT "ZielString = ",  zielString$
END IF


END SUB

REM ****************** FUNKTION, ARRAYS ,SCHLEIFE und SELECT CASE ***
FUNCTION demoArray% (BYVAL intVar%)
DIM usertyp AS typ
DIM intArray(5) AS INTEGER

FOR i%=1 TO 5
 intArray(i%) = i%
 userTyp.intArray(i%) = 5 + i%
NEXT i%


SELECT CASE intVar%
CASE 1
	PRINT intArray(1), ", ", userTyp.intArray(1)
CASE 2 TO 5
	PRINT intArray(intVar%), ", ", userTyp.intArray(intVar%)
CASE ELSE
	PRINT "Index out of Range"
END SELECT

demoArray% = userTyp.intArray(intVar%)

END SUB

REM ****************** LOKALE/GLOBALE VARIABLEN *****************
CONST PI = 3.141592
COMMON SHARED globalVar%
SUB demoVar(intVar%)
INTEGER localVar%

localVar% = 2 * PI

globalVar% = localVar% * intVar%


END SUB