/* BASIC -> C Uebersetzung vom Wed Aug 20 19:13:24 1997
 *
 * Modul: Z:\MS\ARAMIS\SAMPLES\C\DEMO.C
 *
 */

#include "DEMO.H"




void	main(void)
{
Feld   intarrayI_f = NULLFELD;	
		/* Initialisierung */
	B_initstring(DSTR,MAXSTRING,M_AXSP);
	B_initfeld(21);
	B_init(2);
	
	/* Benutzerprogramm */
		/* Im Kopf des Konvertats wird ein Headerfile 'demo.h' */
		/* mit folgendem Inhalt eingebunden : */
		/* - Definitionen (Windows,...) */
		/* - Einbindung der Headerdatei fuer die Library */
		/* - Auflistung aller Konstanten (Defines) */
		/* - Einbindung der Headerdatei 'demo.typ' (Konvertat) */
		/* - Einbindung der Headerdatei 'vcommon.h' (Konvertat) */
		/* - Einbindung der Headerdatei 'projekt.h' (User) */
		/* - Deklaration von Funktionen, Prozeduren und Variablen */
		/* ALLGEMEIN */
		/* Das Konvertat jeder Datei.BAS besteht aus folgenden Dateien: */
		/* - C/CPP-Files datei.c/cpp */
		/* - Headerfile datei.h (s.o.) */
		/* - TYP-File mit den Usertypes */
		/* - vcommon.c/cpp mit globalen Variablen (bei Einstellung) */
		/* - vcommon.h mit Deklaration der entsprechenden Variablen */
#undef PI
#define PI	(3.141592)

	// COMMON  SHARED globalvar%;
	GVglobalvarI=0;
	P_demofile();
	P_demostring();
	GVglobalvarI=F_demoarray(REFHI(2));
	P_demovar(REFHI(1));
		/*  ****************** FILE I/O ************************ */
	B_exit(0);
}

void   P_demofile(void)
{
	typ	usertyp = {0};	
	 
	usertyp.intvar=1;
	B_typecpy(usertyp.stringvar ,sizeof(usertyp.stringvar ),"USER1 ");
	B_open("RANDOM",1,"datei1.txt",sizeof(usertyp));
	B_putk(1, 1,sizeof(usertyp),&(usertyp));
	B_close(1);
	B_open("RANDOM",1,"datei1.txt",sizeof(usertyp));
	B_getk(1, 1,sizeof(usertyp),&(usertyp));
	B_open("OUTPUT",2,"datei2.txt",-1);
	B_fprintf(2,"%d\t, \t%.*s\n",usertyp.intvar,sizeof(usertyp.stringvar),(usertyp.stringvar));
	B_closeall();
}
	/*  ****************** STRINGS ************************ */

void   P_demostring(void)
{
	typ	usertyp = {0};	B_String fixstringS = B_ldrealloc(MAXSTRING);
	B_String quellstringS = B_ldrealloc(MAXSTRING);
	B_String zielstringS = B_ldrealloc(MAXSTRING);
	
	 
	 
	 
	 
	quellstringS=B_nsprintf(quellstringS ,"links mitte rechts",18);
	fixstringS=B_strcpy(fixstringS ,quellstringS);
	B_typecpy(usertyp.stringvar ,sizeof(usertyp.stringvar ),B_right(quellstringS, 6));
	zielstringS =B_sprintf(zielstringS ,"%.*s%s%.*s",sizeof(fixstringS),(fixstringS),(B_mid(quellstringS,7, 6)),sizeof(usertyp.stringvar),(usertyp.stringvar));
	if((long)(B_strcmp(6,zielstringS,quellstringS)))
	{
		B_printf(-1,-1,"Fehler bei String-Konkatenation\n");
	}
	else
	{
		B_printf(-1,-1,"QuellString = \t%s\n",(quellstringS));
		B_printf(-1,-1,"ZielString = \t%s\n",(zielstringS));
	}
	B_dsfree(zielstringS);
	B_dsfree(quellstringS);
	B_dsfree(fixstringS);
}
	/*  ****************** FUNKTION, ARRAYS ,SCHLEIFE und SELECT CASE *** */

B_Int  F_demoarray(B_Int  huge *intvarI)
{
	B_Int  demoarrayI = 0;
	typ	usertyp = {0};
Feld   intarrayI_f = NULLFELD;
	B_Int  iI = 0;
	
	 
	/* DIM intarray(5) */
	intarrayI_f.p.I = (B_Int  huge *)B_dim(DIM_INT,&intarrayI_f,0,1,(long)5);
	for(iI=1;iI<=5;(iI)++)
	{
		intarrayI_f.p.I[iI]=iI;
	}
	switch( *intvarI)
	{
		case 1:
			B_printf(-1,-1,"%d\n",intarrayI_f.p.I[1]);
			break;
		default:
			if((( *intvarI) >= 2  && ( *intvarI) <= 5))
			{
				B_printf(-1,-1,"%d\n",intarrayI_f.p.I[ *intvarI]);
			}
			else
			{
				B_printf(-1,-1,"Index out of Range\n");
			}
			break;
		}
	demoarrayI=intarrayI_f.p.I[ *intvarI];
	B_free(&intarrayI_f);
	return(demoarrayI);
}
	/*  ****************** LOKALE/GLOBALE VARIABLEN ***************** */

void   P_demovar(B_Int  huge *intvarI)
{
	B_Int  localvarI = 0;
	
	 
	localvarI=2*PI;
	GVglobalvarI=localvarI* *intvarI;
}	
	